%define anolis_release 1

%global _hardened_build 1
%bcond_without cvs_enables_contrib
%bcond_with cvs_enables_extra_test
%bcond_without cvs_enables_kerberos
%bcond_without cvs_enables_pam
%bcond_with cvs_enables_xinetd

Name:       cvs
Version:    1.11.23
Release:    %{anolis_release}%{?dist}
Summary:    Concurrent Versions System
URL:        http://cvs.nongnu.org/
License:    BSD and GPL+ and GPLv2+ and LGPLv2+ and zlib and Public Domain
Source0:    ftp://ftp.gnu.org/non-gnu/cvs/source/stable/%{version}/cvs-%{version}.tar.bz2
Source1:    cvs.xinetd
Source2:    cvs.pam
Source3:    cvs.sh
Source4:    cvs.csh
Source5:    cvs@.service
Source6:    cvs.socket
Source7:    cvs.target
Source8:    cvs.sh.5
Source9:    cvs.csh.5
Patch0:     cvs-1.11.23-cvspass.patch
Patch1:     cvs-1.11.19-extzlib.patch
Patch2:     cvs-1.11.19-netbsd-tag.patch
Patch3:     cvs-1.11.19-abortabort.patch
Patch4:     cvs-1.11.1p1-bs.patch
Patch5:     cvs-1.11.21-proxy.patch
Patch7:     cvs-1.11.19-logmsg.patch
Patch8:     cvs-1.11.19-tagname.patch
Patch9:     cvs-1.11.19-comp.patch
Patch11:    cvs-1.11.19-tmp.patch
Patch12:    cvs-1.11.21-pam.patch
Patch13:    cvs-1.11.21-diff.patch
Patch14:    cvs-1.11.21-diff-kk.patch
Patch15:    cvs-1.11.21-sort.patch
Patch17:    cvs-1.11.22-ipv6-proxy.patch
Patch19:    cvs-1.11.23-getline64.patch
Patch20:    cvs-1.11.22-stdinargs.patch
Patch21:    cvs-1.11.23-cve-2010-3846.patch
Patch22:    cvs-1.11.23-remove_undefined_date_from_cvs_1_header.patch
Patch23:    cvs-1.11.23-sanity.patch
Patch24:    cvs-1.11.23-make_make_check_sanity_testing_verbose.patch
Patch25:    cvs-1.11.23-Set-PAM_TTY-and-PAM_RHOST-on-PAM-authentication.patch
Patch26:    cvs-1.11.23-Back-port-KeywordExpand-configuration-keyword.patch
Patch27:    cvs-1.11.23-Allow-CVS-server-to-use-any-Kerberos-key-with-cvs-se.patch
Patch28:    cvs-1.11.23-Fix-proxy-response-parser.patch
Patch29:    cvs-1.11.23-doc-Add-mandatory-argument-to-sp.patch
Patch30:    cvs-1.11.23-crypt-2.diff
Patch31:    cvs-1.11.23-Pass-compilation-with-Wformat-security.patch
Patch32:    cvs-1.11.23-Fix-CVE-2017-12836.patch
Patch33:    cvs-1.11.23-Close-a-configuration-file-on-a-syntax-error.patch
Patch34:    cvs-1.11.23-Use-diff-label.patch
Patch35:    cvs-1.11.23-c99.patch

BuildRequires:  autoconf >= 2.58 automake >= 1.7.9 coreutils libtool make
BuildRequires:  gzip glibc-common systemd
BuildRequires:	texinfo vim-minimal zlib-devel 

%if %{with cvs_enables_kerberos}
BuildRequires:  krb5-devel
%endif
%if %{with cvs_enables_pam}
BuildRequires:  pam-devel
%endif
%if %{with cvs_enables_contrib}
BuildRequires:  perl-generators
%endif

Requires:       vim-minimal

%description
CVS (Concurrent Versions System) is a version control system that can
record the history of your files (usually, but not always, source
code). CVS only stores the differences between versions, instead of
every version of every file you have ever created. CVS also keeps a log
of who, when, and why changes occurred.

CVS is very helpful for managing releases and controlling the
concurrent editing of source files among multiple authors. Instead of
providing version control for a collection of files in a single
directory, CVS provides version control for a hierarchical collection
of directories consisting of revision controlled files. These
directories and files can then be combined together to form a software
release.


%if %{with cvs_enables_contrib}
%package contrib
Summary: Unsupported contributions collected by CVS developers
License: GPLv2+ and Copyright only
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description contrib
Scripts sent to CVS developers by contributors around the world. These
contributions are really unsupported.
%endif


%if %{with cvs_enables_xinetd}
%package inetd
Summary: CVS server configuration for xinetd
License: GPL+
Requires: %{name} = %{version}-%{release}
Requires: xinetd
BuildArch: noarch

%description inetd
A CVS server can be run locally, via a remote shell or by an inetd server.
This package provides a configuration for xinetd, an inetd implementation.
%endif

%package doc
Summary: Additional documentation for Concurrent Versions System
License: GPL+
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
FAQ, RCS format description, parallel development how-to, and Texinfo
pages in PDF.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%if !%{with cvs_enables_extra_test}
%patch4 -p1
%endif
%patch5 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch11 -p1
%if %{with cvs_enables_pam}
%patch12 -p1
%endif
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch17 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1

%build
autoreconf --install

%if %{with cvs_enables_pam}
    PAM_CONFIG="--enable-pam"
%endif

%if %{with cvs_enables_kerberos}
    k5prefix=`krb5-config --prefix`
    CPPFLAGS=-I${k5prefix}/include/kerberosIV; export CPPFLAGS
    CFLAGS=-I${k5prefix}/include/kerberosIV; export CFLAGS
    LIBS="-lk5crypto"; export LIBS
    KRB_CONFIG="--with-gssapi --without-krb4 --enable-encryption"
%endif

%configure CFLAGS="$CFLAGS $RPM_OPT_FLAGS \
    -D_FILE_OFFSET_BITS=64 %-D_LARGEFILE64_SOURCE" \
    $PAM_CONFIG $KRB_CONFIG CSH=/bin/csh

%{make_build}

%check
if [ $(id -u) -ne 0 ] ; then
    make check
fi

%install
%{make_install}
gzip $RPM_BUILD_ROOT/%{_infodir}/cvs* || true
rm -f $RPM_BUILD_ROOT/%{_infodir}/dir

%if %{with cvs_enables_xinetd}
    install -D -m 644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/xinetd.d/%{name}
%endif
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/%{name}
%if %{with cvs_enables_pam}
    install -D -m 644 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/cvs
%endif
install -D -m 644 %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/profile.d/cvs.sh
install -D -m 644 %{SOURCE4} $RPM_BUILD_ROOT/%{_sysconfdir}/profile.d/cvs.csh
install -p -m 644 -D %{SOURCE5} $RPM_BUILD_ROOT%{_unitdir}/cvs\@.service
install -p -m 644 -D %{SOURCE6} $RPM_BUILD_ROOT%{_unitdir}/cvs.socket
install -p -m 644 -D %{SOURCE7} $RPM_BUILD_ROOT%{_unitdir}/cvs.target
install -D -m 644 %{SOURCE8} $RPM_BUILD_ROOT/%{_mandir}/man5/cvs.sh.5
install -D -m 644 %{SOURCE9} $RPM_BUILD_ROOT/%{_mandir}/man5/cvs.csh.5

%if !%{with cvs_enables_contrib}
rm -f $RPM_BUILD_ROOT/%{_bindir}/rcs2log
rm -fr $RPM_BUILD_ROOT/%{_datadir}/%{name}
%endif

%post
%systemd_post cvs.socket
exit 0

%preun
%systemd_preun cvs.socket
%systemd_preun cvs.target
exit 0

%postun
%systemd_postun_with_restart cvs.socket


%files
%license COPYING*
%{_bindir}/cvs*
%{_mandir}/*/*
%{_infodir}/*.info*
%dir %{_localstatedir}/%{name}
%if %{with cvs_enables_pam}
%config(noreplace) %{_sysconfdir}/pam.d/*
%endif
%config(noreplace) %{_sysconfdir}/profile.d/*
%{_unitdir}/*

%if %{with cvs_enables_contrib}
%files contrib
%{_bindir}/rcs2log
%{_datadir}/%{name}
%endif

%if %{with cvs_enables_xinetd}
%files inetd
%config(noreplace) %{_sysconfdir}/xinetd.d/%{name}
%endif

%files doc
%doc FAQ doc/RCSFILES doc/*.pdf
%doc AUTHORS BUGS DEVEL-CVS HACKING MINOR-BUGS NEWS PROJECTS TODO README

%changelog
* Thu May 11 2023 happy_orange <songnannan@linux.alibaba.com> - 1.11.23-1
- init package
